#!/bin/sh

DL_file_path=$1
[ "${DL_file_path::7}" != "http://" ] && DL_file_path=http://${DL_file_path}
image_name=$(/usr/bin/basename ${DL_file_path})

#get sdx1 disk list
/bin/echo Finding disk information
disk=$(/bin/grep "sd.1" /proc/partitions | /bin/awk '{print $4}')
[ -z "${disk}" ] && { /bin/sleep 30; disk=$(/bin/grep "sd.1" /proc/partitions | /bin/awk '{print $4}'); }
if [ -z "${disk}" ]; then
	/bin/echo Can not find disk information
	exit 10
fi
for i in ${disk}
do
	disk_list="${disk_list}/dev/${i} "
done


/sbin/mdadm -A /dev/md9 ${disk_list} --run &>/dev/null
/bin/mkdir /mnt/HDA_ROOT/ &>/dev/null
/bin/mount /dev/md9 /mnt/HDA_ROOT/
if [ $? != 0 -o -z "$(/bin/df | /bin/grep "/dev/md9")" ]; then
	/bin/echo Can not mount /dev/md9
	exit 11
fi


#get image and ready to recover
cd /mnt/HDA_ROOT/
/bin/echo Downlaoding image file
busybox wget "${DL_file_path}" -O ${image_name}
if [ $? != 0 ]; then
	/bin/echo Download ${image_name} faile.
	exit 12
fi
/usr/bin/unzip ${image_name}
/bin/rm ${image_name}


#recover image
/bin/echo recover image
/bin/mkdir /mnt/HDA_ROOT/update &>/dev/null
/bin/rm -rf /mnt/update
/bin/rm -f /tmp/update_process
/bin/ln -sf /mnt/HDA_ROOT/update /mnt/update
image_file=$(/bin/ls -lS *.img | /bin/awk '{print $9}' | /usr/bin/head -1)
/etc/init.d/update.sh ${image_file} | /usr/bin/tee check_if_success.txt
if [ -z "$(/bin/grep "Update Finished" check_if_success.txt 2>/dev/null)" ]; then
	/bin/echo Update image failed
	exit 13
fi

/sbin/reboot
exit 100
